setup-ipsec-vpn/vpnsetup_centos.sh

542 lines
16 KiB
Bash
Raw Normal View History

#!/bin/sh
#
2021-01-01 06:09:58 +01:00
# Script for automatic setup of an IPsec VPN server on CentOS/RHEL 7 and 8
2021-01-07 17:32:20 +01:00
# Works on any dedicated server or virtual private server (VPS)
#
2016-10-11 05:34:51 +02:00
# DO NOT RUN THIS SCRIPT ON YOUR PC OR MAC!
#
# The latest version of this script is available at:
# https://github.com/hwdsl2/setup-ipsec-vpn
#
2021-01-03 07:35:24 +01:00
# Copyright (C) 2015-2021 Lin Song <linsongui@gmail.com>
# Based on the work of Thomas Sarlandie (Copyright 2012)
#
2016-04-21 00:31:29 +02:00
# This work is licensed under the Creative Commons Attribution-ShareAlike 3.0
# Unported License: http://creativecommons.org/licenses/by-sa/3.0/
#
# Attribution required: please include my name in any derivative and let me
2016-04-21 00:31:29 +02:00
# know how you have improved it!
2016-06-21 05:35:45 +02:00
# =====================================================
2016-01-22 00:00:51 +01:00
2016-04-21 00:31:29 +02:00
# Define your own values for these variables
2016-06-11 22:36:43 +02:00
# - IPsec pre-shared key, VPN username and password
2016-06-02 04:16:15 +02:00
# - All values MUST be placed inside 'single quotes'
2017-11-01 07:01:49 +01:00
# - DO NOT use these special characters within values: \ " '
2016-06-11 22:36:43 +02:00
YOUR_IPSEC_PSK=''
YOUR_USERNAME=''
YOUR_PASSWORD=''
2016-08-07 21:00:07 +02:00
# Important notes: https://git.io/vpnnotes
# Setup VPN clients: https://git.io/vpnclients
# IKEv2 guide: https://git.io/ikev2
2016-06-21 05:35:45 +02:00
# =====================================================
export PATH="/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin"
2020-06-05 17:56:33 +02:00
SYS_DT=$(date +%F-%T | tr ':' '_')
2016-11-07 02:30:53 +01:00
exiterr() { echo "Error: $1" >&2; exit 1; }
2017-11-01 07:01:49 +01:00
exiterr2() { exiterr "'yum install' failed."; }
2017-11-02 04:15:56 +01:00
conf_bk() { /bin/cp -f "$1" "$1.old-$SYS_DT" 2>/dev/null; }
bigecho() { echo; echo "## $1"; echo; }
2016-11-07 02:30:53 +01:00
check_ip() {
IP_REGEX='^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$'
2017-11-01 07:01:49 +01:00
printf '%s' "$1" | tr -d '\n' | grep -Eq "$IP_REGEX"
}
2016-01-21 18:50:35 +01:00
vpnsetup() {
2021-01-03 21:05:13 +01:00
os_type=centos
os_arch=$(uname -m | tr -dc 'A-Za-z0-9_-')
if grep -qs "Red Hat" /etc/redhat-release; then
os_type=rhel
fi
if grep -qs "release 7" /etc/redhat-release; then
os_ver=7
elif grep -qs "release 8" /etc/redhat-release; then
os_ver=8
else
echo "Error: This script only supports CentOS/RHEL 7 and 8." >&2
2020-01-13 09:07:39 +01:00
echo "For Ubuntu/Debian, use https://git.io/vpnsetup" >&2
exit 1
fi
2016-01-30 20:12:15 +01:00
if [ -f /proc/user_beancounters ]; then
exiterr "OpenVZ VPS is not supported."
fi
if [ "$(id -u)" != 0 ]; then
2016-06-29 09:40:52 +02:00
exiterr "Script must be run as root. Try 'sudo sh $0'"
fi
def_iface=$(route 2>/dev/null | grep -m 1 '^default' | grep -o '[^ ]*$')
[ -z "$def_iface" ] && def_iface=$(ip -4 route list 0/0 2>/dev/null | grep -m 1 -Po '(?<=dev )(\S+)')
2018-05-23 08:39:53 +02:00
def_state=$(cat "/sys/class/net/$def_iface/operstate" 2>/dev/null)
if [ -n "$def_state" ] && [ "$def_state" != "down" ]; then
2021-01-01 06:09:58 +01:00
case $def_iface in
2018-02-03 23:10:09 +01:00
wl*)
exiterr "Wireless interface '$def_iface' detected. DO NOT run this script on your PC or Mac!"
;;
esac
NET_IFACE="$def_iface"
else
eth0_state=$(cat "/sys/class/net/eth0/operstate" 2>/dev/null)
if [ -z "$eth0_state" ] || [ "$eth0_state" = "down" ]; then
exiterr "Could not detect the default network interface."
fi
NET_IFACE=eth0
2016-01-19 08:26:12 +01:00
fi
2016-06-11 22:36:43 +02:00
[ -n "$YOUR_IPSEC_PSK" ] && VPN_IPSEC_PSK="$YOUR_IPSEC_PSK"
[ -n "$YOUR_USERNAME" ] && VPN_USER="$YOUR_USERNAME"
[ -n "$YOUR_PASSWORD" ] && VPN_PASSWORD="$YOUR_PASSWORD"
2016-06-02 04:16:15 +02:00
if [ -z "$VPN_IPSEC_PSK" ] && [ -z "$VPN_USER" ] && [ -z "$VPN_PASSWORD" ]; then
bigecho "VPN credentials not set by user. Generating random PSK and password..."
2019-01-12 08:08:04 +01:00
VPN_IPSEC_PSK=$(LC_CTYPE=C tr -dc 'A-HJ-NPR-Za-km-z2-9' < /dev/urandom | head -c 20)
2016-05-14 07:35:33 +02:00
VPN_USER=vpnuser
2019-01-12 08:08:04 +01:00
VPN_PASSWORD=$(LC_CTYPE=C tr -dc 'A-HJ-NPR-Za-km-z2-9' < /dev/urandom | head -c 16)
2016-05-14 07:35:33 +02:00
fi
if [ -z "$VPN_IPSEC_PSK" ] || [ -z "$VPN_USER" ] || [ -z "$VPN_PASSWORD" ]; then
2016-06-29 09:40:52 +02:00
exiterr "All VPN credentials must be specified. Edit the script and re-enter them."
2016-01-17 22:39:08 +01:00
fi
2017-11-01 07:01:49 +01:00
if printf '%s' "$VPN_IPSEC_PSK $VPN_USER $VPN_PASSWORD" | LC_ALL=C grep -q '[^ -~]\+'; then
exiterr "VPN credentials must not contain non-ASCII characters."
fi
case "$VPN_IPSEC_PSK $VPN_USER $VPN_PASSWORD" in
*[\\\"\']*)
2017-11-01 07:01:49 +01:00
exiterr "VPN credentials must not contain these special characters: \\ \" '"
;;
esac
2020-08-09 21:49:02 +02:00
if { [ -n "$VPN_DNS_SRV1" ] && ! check_ip "$VPN_DNS_SRV1"; } \
|| { [ -n "$VPN_DNS_SRV2" ] && ! check_ip "$VPN_DNS_SRV2"; } then
exiterr "The DNS server specified is invalid."
2020-06-12 18:05:42 +02:00
fi
bigecho "VPN setup in progress... Please be patient."
2016-05-17 05:42:30 +02:00
# Create and change to working dir
mkdir -p /opt/src
2018-05-23 08:39:53 +02:00
cd /opt/src || exit 1
bigecho "Installing packages required for setup..."
2017-01-09 09:23:09 +01:00
yum -y install wget bind-utils openssl tar \
iptables iproute gawk grep sed net-tools || exiterr2
bigecho "Trying to auto discover IP of this server..."
2016-05-21 10:59:08 +02:00
2017-01-09 09:23:09 +01:00
cat <<'EOF'
2016-05-21 10:59:08 +02:00
In case the script hangs here for more than a few minutes,
2017-11-01 07:01:49 +01:00
press Ctrl-C to abort. Then edit it and manually enter IP.
2016-05-21 10:59:08 +02:00
EOF
# In case auto IP discovery fails, enter server's public IP here.
2016-06-02 04:16:15 +02:00
PUBLIC_IP=${VPN_PUBLIC_IP:-''}
2016-06-26 20:00:11 +02:00
[ -z "$PUBLIC_IP" ] && PUBLIC_IP=$(dig @resolver1.opendns.com -t A -4 myip.opendns.com +short)
check_ip "$PUBLIC_IP" || PUBLIC_IP=$(wget -t 3 -T 15 -qO- http://ipv4.icanhazip.com)
2017-11-01 07:01:49 +01:00
check_ip "$PUBLIC_IP" || exiterr "Cannot detect this server's public IP. Edit the script and manually enter it."
bigecho "Adding the EPEL repository..."
2017-01-09 09:23:09 +01:00
epel_url="https://dl.fedoraproject.org/pub/epel/epel-release-latest-$(rpm -E '%{rhel}').noarch.rpm"
yum -y install epel-release || yum -y install "$epel_url" || exiterr2
bigecho "Installing packages required for the VPN..."
2017-01-09 09:23:09 +01:00
REPO1='--enablerepo=epel'
REPO2='--enablerepo=*server-*optional*'
REPO3='--enablerepo=*releases-optional*'
REPO4='--enablerepo=[Pp]ower[Tt]ools'
[ "$os_type" = "rhel" ] && REPO4='--enablerepo=codeready-builder-for-rhel-8-*'
yum -y install nss-devel nspr-devel pkgconfig pam-devel \
libcap-ng-devel libselinux-devel curl-devel nss-tools \
flex bison gcc make ppp || exiterr2
yum "$REPO1" -y install xl2tpd || exiterr2
use_nft=0
if [ "$os_ver" = "7" ]; then
yum -y install systemd-devel iptables-services || exiterr2
yum "$REPO2" "$REPO3" -y install libevent-devel fipscheck-devel || exiterr2
else
yum "$REPO4" -y install systemd-devel libevent-devel fipscheck-devel || exiterr2
2020-08-09 21:49:02 +02:00
if systemctl is-active --quiet firewalld.service \
|| grep -qs "hwdsl2 VPN script" /etc/sysconfig/nftables.conf; then
use_nft=1
yum -y install nftables || exiterr2
else
yum -y install iptables-services || exiterr2
fi
fi
bigecho "Installing Fail2Ban to protect SSH..."
2017-01-09 09:23:09 +01:00
yum "$REPO1" -y install fail2ban || exiterr2
2017-01-09 09:23:09 +01:00
bigecho "Compiling and installing Libreswan..."
2017-01-09 09:23:09 +01:00
SWAN_VER=4.2
2017-11-01 07:01:49 +01:00
swan_file="libreswan-$SWAN_VER.tar.gz"
swan_url1="https://github.com/libreswan/libreswan/archive/v$SWAN_VER.tar.gz"
swan_url2="https://download.libreswan.org/$swan_file"
2016-10-11 05:34:51 +02:00
if ! { wget -t 3 -T 30 -nv -O "$swan_file" "$swan_url1" || wget -t 3 -T 30 -nv -O "$swan_file" "$swan_url2"; }; then
2018-05-23 08:39:53 +02:00
exit 1
2016-10-11 05:34:51 +02:00
fi
2017-11-01 07:01:49 +01:00
/bin/rm -rf "/opt/src/libreswan-$SWAN_VER"
2016-05-21 12:34:19 +02:00
tar xzf "$swan_file" && /bin/rm -f "$swan_file"
2018-05-23 08:39:53 +02:00
cd "libreswan-$SWAN_VER" || exit 1
2017-08-20 17:52:28 +02:00
cat > Makefile.inc.local <<'EOF'
WERROR_CFLAGS=-w
USE_DNSSEC=false
USE_DH2=true
USE_NSS_KDF=false
FINALNSSDIR=/etc/ipsec.d
2017-08-20 17:52:28 +02:00
EOF
if ! grep -qs IFLA_XFRM_LINK /usr/include/linux/if_link.h; then
echo "USE_XFRM_INTERFACE_IFLA_HEADER=true" >> Makefile.inc.local
fi
2019-01-12 08:08:04 +01:00
NPROCS=$(grep -c ^processor /proc/cpuinfo)
[ -z "$NPROCS" ] && NPROCS=1
make "-j$((NPROCS+1))" -s base && make -s install-base
2018-05-23 08:39:53 +02:00
cd /opt/src || exit 1
2017-11-01 07:01:49 +01:00
/bin/rm -rf "/opt/src/libreswan-$SWAN_VER"
if ! /usr/local/sbin/ipsec --version 2>/dev/null | grep -qF "$SWAN_VER"; then
exiterr "Libreswan $SWAN_VER failed to build."
2016-10-11 05:34:51 +02:00
fi
2016-01-21 18:50:35 +01:00
bigecho "Creating VPN configuration..."
L2TP_NET=${VPN_L2TP_NET:-'192.168.42.0/24'}
L2TP_LOCAL=${VPN_L2TP_LOCAL:-'192.168.42.1'}
L2TP_POOL=${VPN_L2TP_POOL:-'192.168.42.10-192.168.42.250'}
XAUTH_NET=${VPN_XAUTH_NET:-'192.168.43.0/24'}
XAUTH_POOL=${VPN_XAUTH_POOL:-'192.168.43.10-192.168.43.250'}
DNS_SRV1=${VPN_DNS_SRV1:-'8.8.8.8'}
DNS_SRV2=${VPN_DNS_SRV2:-'8.8.4.4'}
DNS_SRVS="\"$DNS_SRV1 $DNS_SRV2\""
[ -n "$VPN_DNS_SRV1" ] && [ -z "$VPN_DNS_SRV2" ] && DNS_SRVS="$DNS_SRV1"
2017-01-09 09:23:09 +01:00
2018-05-23 08:39:53 +02:00
# Create IPsec config
2016-10-11 05:34:51 +02:00
conf_bk "/etc/ipsec.conf"
cat > /etc/ipsec.conf <<EOF
version 2.0
config setup
virtual-private=%v4:10.0.0.0/8,%v4:192.168.0.0/16,%v4:172.16.0.0/12,%v4:!$L2TP_NET,%v4:!$XAUTH_NET
interfaces=%defaultroute
uniqueids=no
conn shared
left=%defaultroute
leftid=$PUBLIC_IP
right=%any
encapsulation=yes
authby=secret
pfs=no
rekey=no
keyingtries=5
dpddelay=30
dpdtimeout=120
dpdaction=clear
ikev2=never
ike=aes256-sha2,aes128-sha2,aes256-sha1,aes128-sha1,aes256-sha2;modp1024,aes128-sha1;modp1024
phase2alg=aes_gcm-null,aes128-sha1,aes256-sha1,aes256-sha2_512,aes128-sha2,aes256-sha2
ikelifetime=24h
salifetime=24h
sha2-truncbug=no
conn l2tp-psk
auto=add
leftprotoport=17/1701
rightprotoport=17/%any
type=transport
phase2=esp
also=shared
conn xauth-psk
auto=add
leftsubnet=0.0.0.0/0
rightaddresspool=$XAUTH_POOL
modecfgdns=$DNS_SRVS
leftxauthserver=yes
rightxauthclient=yes
leftmodecfgserver=yes
rightmodecfgclient=yes
modecfgpull=yes
xauthby=file
fragmentation=yes
cisco-unity=yes
also=shared
include /etc/ipsec.d/*.conf
EOF
2016-01-17 22:39:08 +01:00
# Specify IPsec PSK
2016-10-11 05:34:51 +02:00
conf_bk "/etc/ipsec.secrets"
cat > /etc/ipsec.secrets <<EOF
%any %any : PSK "$VPN_IPSEC_PSK"
EOF
2016-01-17 22:39:08 +01:00
# Create xl2tpd config
2016-10-11 05:34:51 +02:00
conf_bk "/etc/xl2tpd/xl2tpd.conf"
cat > /etc/xl2tpd/xl2tpd.conf <<EOF
[global]
port = 1701
[lns default]
ip range = $L2TP_POOL
local ip = $L2TP_LOCAL
require chap = yes
refuse pap = yes
require authentication = yes
name = l2tpd
pppoptfile = /etc/ppp/options.xl2tpd
length bit = yes
EOF
2016-05-17 05:42:30 +02:00
# Set xl2tpd options
2016-10-11 05:34:51 +02:00
conf_bk "/etc/ppp/options.xl2tpd"
cat > /etc/ppp/options.xl2tpd <<EOF
+mschap-v2
ipcp-accept-local
ipcp-accept-remote
noccp
auth
mtu 1280
mru 1280
2016-06-11 02:34:59 +02:00
proxyarp
lcp-echo-failure 4
lcp-echo-interval 30
connect-delay 5000
ms-dns $DNS_SRV1
EOF
if [ -z "$VPN_DNS_SRV1" ] || [ -n "$VPN_DNS_SRV2" ]; then
cat >> /etc/ppp/options.xl2tpd <<EOF
ms-dns $DNS_SRV2
EOF
fi
2016-01-17 22:39:08 +01:00
# Create VPN credentials
2016-10-11 05:34:51 +02:00
conf_bk "/etc/ppp/chap-secrets"
cat > /etc/ppp/chap-secrets <<EOF
"$VPN_USER" l2tpd "$VPN_PASSWORD" *
EOF
2016-10-11 05:34:51 +02:00
conf_bk "/etc/ipsec.d/passwd"
VPN_PASSWORD_ENC=$(openssl passwd -1 "$VPN_PASSWORD")
2016-07-04 00:54:15 +02:00
cat > /etc/ipsec.d/passwd <<EOF
$VPN_USER:$VPN_PASSWORD_ENC:xauth-psk
EOF
bigecho "Updating sysctl settings..."
2017-01-09 09:23:09 +01:00
if ! grep -qs "hwdsl2 VPN script" /etc/sysctl.conf; then
2016-10-11 05:34:51 +02:00
conf_bk "/etc/sysctl.conf"
cat >> /etc/sysctl.conf <<EOF
# Added by hwdsl2 VPN script
kernel.msgmnb = 65536
kernel.msgmax = 65536
net.ipv4.ip_forward = 1
net.ipv4.conf.all.accept_redirects = 0
net.ipv4.conf.all.send_redirects = 0
net.ipv4.conf.all.rp_filter = 0
net.ipv4.conf.default.accept_redirects = 0
net.ipv4.conf.default.send_redirects = 0
net.ipv4.conf.default.rp_filter = 0
net.ipv4.conf.$NET_IFACE.send_redirects = 0
net.ipv4.conf.$NET_IFACE.rp_filter = 0
net.core.wmem_max = 12582912
net.core.rmem_max = 12582912
net.ipv4.tcp_rmem = 10240 87380 12582912
net.ipv4.tcp_wmem = 10240 87380 12582912
EOF
fi
2020-08-09 21:49:02 +02:00
F2B_FILE=/etc/fail2ban/jail.local
if [ ! -f "$F2B_FILE" ]; then
bigecho "Creating basic Fail2Ban rules..."
cat > "$F2B_FILE" <<'EOF'
[ssh-iptables]
enabled = true
filter = sshd
logpath = /var/log/secure
EOF
if [ "$use_nft" = "1" ]; then
cat >> "$F2B_FILE" <<'EOF'
port = ssh
banaction = nftables-multiport[blocktype=drop]
EOF
else
cat >> "$F2B_FILE" <<'EOF'
action = iptables[name=SSH, port=ssh, protocol=tcp]
EOF
fi
fi
bigecho "Updating IPTables rules..."
2017-01-09 09:23:09 +01:00
2020-08-09 21:49:02 +02:00
IPT_FILE=/etc/sysconfig/iptables
[ "$use_nft" = "1" ] && IPT_FILE=/etc/sysconfig/nftables.conf
ipt_flag=0
if ! grep -qs "hwdsl2 VPN script" "$IPT_FILE"; then
ipt_flag=1
fi
if [ "$ipt_flag" = "1" ]; then
2016-07-10 08:36:41 +02:00
service fail2ban stop >/dev/null 2>&1
if [ "$use_nft" = "1" ]; then
nft list ruleset > "$IPT_FILE.old-$SYS_DT"
chmod 600 "$IPT_FILE.old-$SYS_DT"
else
iptables-save > "$IPT_FILE.old-$SYS_DT"
fi
iptables -I INPUT 1 -p udp --dport 1701 -m policy --dir in --pol none -j DROP
iptables -I INPUT 2 -m conntrack --ctstate INVALID -j DROP
iptables -I INPUT 3 -m conntrack --ctstate RELATED,ESTABLISHED -j ACCEPT
iptables -I INPUT 4 -p udp -m multiport --dports 500,4500 -j ACCEPT
iptables -I INPUT 5 -p udp --dport 1701 -m policy --dir in --pol ipsec -j ACCEPT
iptables -I INPUT 6 -p udp --dport 1701 -j DROP
iptables -I FORWARD 1 -m conntrack --ctstate INVALID -j DROP
iptables -I FORWARD 2 -i "$NET_IFACE" -o ppp+ -m conntrack --ctstate RELATED,ESTABLISHED -j ACCEPT
iptables -I FORWARD 3 -i ppp+ -o "$NET_IFACE" -j ACCEPT
iptables -I FORWARD 4 -i ppp+ -o ppp+ -s "$L2TP_NET" -d "$L2TP_NET" -j ACCEPT
iptables -I FORWARD 5 -i "$NET_IFACE" -d "$XAUTH_NET" -m conntrack --ctstate RELATED,ESTABLISHED -j ACCEPT
iptables -I FORWARD 6 -s "$XAUTH_NET" -o "$NET_IFACE" -j ACCEPT
# Uncomment to disallow traffic between VPN clients
# iptables -I FORWARD 2 -i ppp+ -o ppp+ -s "$L2TP_NET" -d "$L2TP_NET" -j DROP
# iptables -I FORWARD 3 -s "$XAUTH_NET" -d "$XAUTH_NET" -j DROP
iptables -t nat -I POSTROUTING -s "$XAUTH_NET" -o "$NET_IFACE" -m policy --dir out --pol none -j MASQUERADE
iptables -t nat -I POSTROUTING -s "$L2TP_NET" -o "$NET_IFACE" -j MASQUERADE
echo "# Modified by hwdsl2 VPN script" > "$IPT_FILE"
if [ "$use_nft" = "1" ]; then
for vport in 500 4500 1701; do
nft insert rule inet firewalld filter_INPUT udp dport "$vport" accept
done
for vnet in "$L2TP_NET" "$XAUTH_NET"; do
for vdir in saddr daddr; do
nft insert rule inet firewalld filter_FORWARD ip "$vdir" "$vnet" accept
done
done
echo "flush ruleset" >> "$IPT_FILE"
nft list ruleset >> "$IPT_FILE"
else
iptables -A FORWARD -j DROP
iptables-save >> "$IPT_FILE"
fi
fi
bigecho "Enabling services on boot..."
2017-01-09 09:23:09 +01:00
systemctl --now mask firewalld 2>/dev/null
if [ "$use_nft" = "1" ]; then
systemctl enable nftables fail2ban 2>/dev/null
else
systemctl enable iptables fail2ban 2>/dev/null
fi
2018-10-21 07:20:54 +02:00
if ! grep -qs "hwdsl2 VPN script" /etc/rc.local; then
2017-01-04 08:50:41 +01:00
if [ -f /etc/rc.local ]; then
conf_bk "/etc/rc.local"
else
echo '#!/bin/sh' > /etc/rc.local
fi
2016-07-04 00:54:15 +02:00
cat >> /etc/rc.local <<'EOF'
# Added by hwdsl2 VPN script
(sleep 15
2017-01-04 08:50:41 +01:00
service ipsec restart
service xl2tpd restart
echo 1 > /proc/sys/net/ipv4/ip_forward)&
EOF
fi
bigecho "Starting services..."
2017-01-09 09:23:09 +01:00
restorecon /etc/ipsec.d/*db 2>/dev/null
restorecon /usr/local/sbin -Rv 2>/dev/null
restorecon /usr/local/libexec/ipsec -Rv 2>/dev/null
2016-06-21 05:35:45 +02:00
sysctl -e -q -p
2016-01-17 22:39:08 +01:00
2016-04-21 00:31:29 +02:00
chmod +x /etc/rc.local
chmod 600 /etc/ipsec.secrets* /etc/ppp/chap-secrets* /etc/ipsec.d/passwd*
if [ "$use_nft" = "1" ]; then
nft -f "$IPT_FILE"
else
iptables-restore < "$IPT_FILE"
fi
# Fix xl2tpd if l2tp_ppp is unavailable
if ! modprobe -q l2tp_ppp; then
sed -i '/^ExecStartPre=\//s/=/=-/' /usr/lib/systemd/system/xl2tpd.service
systemctl daemon-reload
fi
mkdir -p /run/pluto
service fail2ban restart 2>/dev/null
service ipsec restart 2>/dev/null
service xl2tpd restart 2>/dev/null
2016-01-30 20:12:15 +01:00
2021-01-03 21:05:13 +01:00
swan_ver_url="https://dl.ls20.com/v1/$os_type/$os_ver/swanver?arch=$os_arch&ver=$SWAN_VER"
swan_ver_latest=$(wget -t 3 -T 15 -qO- "$swan_ver_url")
if printf '%s' "$swan_ver_latest" | grep -Eq '^([3-9]|[1-9][0-9])\.([0-9]|[1-9][0-9])$' \
&& [ "$SWAN_VER" != "$swan_ver_latest" ] \
&& printf '%s\n%s' "$SWAN_VER" "$swan_ver_latest" | sort -C -V; then
2021-01-03 21:05:13 +01:00
cat <<EOF
Note: A newer version of Libreswan ($swan_ver_latest) is available.
To update, run:
wget https://git.io/vpnupgrade-centos -O vpnupgrade.sh
sudo sh vpnupgrade.sh
2021-01-03 21:05:13 +01:00
EOF
fi
2016-05-21 10:59:08 +02:00
cat <<EOF
================================================
2016-05-26 21:31:11 +02:00
IPsec VPN server is now ready for use!
2016-05-21 10:59:08 +02:00
Connect to your new VPN with these details:
Server IP: $PUBLIC_IP
IPsec PSK: $VPN_IPSEC_PSK
Username: $VPN_USER
Password: $VPN_PASSWORD
Write these down. You'll need them to connect!
2016-08-07 21:00:07 +02:00
Important notes: https://git.io/vpnnotes
Setup VPN clients: https://git.io/vpnclients
IKEv2 guide: https://git.io/ikev2
2016-05-21 10:59:08 +02:00
================================================
EOF
2016-04-17 23:55:44 +02:00
}
## Defer setup until we have the complete script
vpnsetup "$@"
2016-05-21 10:59:08 +02:00
exit 0